So I upgraded my DietPi kernel the other day and noticed there was no driver for Realtek 8188 driver for that kernel version. After playing around trying to compile the driver for the newest kernel I decided to downgrade the kernel. Thought it was difficult, but it’s quite easy. Only choose the kernel version you want to downgrade to from here, copy the hash and run rpi-update.
rpi-update 48cfa89779408ecd69db4eb793b846fb7fe40c4b
Hash above corresponds to kernel 4.4.11-v7+, with that kernel I was able to download the driver for my USB wifi using the script below:
#!/bin/bash
set -e
TOPIC_URL="http://www.raspberrypi.org/phpBB3/viewtopic.php?p=462982"
# Download and install rpi driver for 8188eu-based wifi dongles
# from MrEngman's dropbox.
#
# Version information is fetched from TOPIC_URL and appears as:
#
# 3.6.11+ #371 up to #520 inclusive - 8188eu-20130209.tar.gz
# 3.6.11+ #524, #528, #532 - 8188eu-20130815.tar.gz
# ...
# then is matched against local kernel release and version numbers
# to select proper driver tarball. Kernel build number can be overriden
# with command line option -k, in case no exact match is found.
fetch_versions() {
curl -s "$TOPIC_URL" \
| sed 's:<code>\|</code>\|<br />:\n:g' \
| sed 's: : :g ; s:gz.*:gz:' \
| grep -E '^[0-9.]+.*tar\.gz'
}
case "$1" in
-k|--kernel)
build=$2
;;
-l|--list)
fetch_versions
exit 0
;;
-h|--help)
echo "usage: `basename $0`" \
"[-k|--kernel <kernel build>]" \
"[-l|--list]"
exit 0
;;
"")
;; # proceed to install
*)
echo "unknown command: $1" >&2
$0 --help
exit 1
;;
esac
kernel=$(uname -r)
build=${build:-$(uname -v | awk '{print $1}' | tr -d '#')}
if [ $kernel = "3.6.11+" ] && [ $build -gt 370 ] && [ $build -lt 521 ] ; then
tarfile=8188eu-20130209.tar.gz
else
tarfile=$(fetch_versions \
| grep -e "^$kernel " \
| grep -E "#$build[, ]" \
| awk '{print $NF}')
fi
if [ ! "$tarfile" ] ; then
echo "cannot match kernel: $kernel #$build"
echo "please check news at $TOPIC_URL"
echo "or try closest compatible version with -k <kernel build>"
exit 1
fi
tmpdir=$(mktemp -d)
trap "\rm -rf $tmpdir" EXIT
cd $tmpdir
echo "downloading $tarfile (kernel $kernel #$build)"
curl -s https://dl.dropboxusercontent.com/u/80256631/$tarfile | tar xz
module_bin="8188eu.ko"
module_dir="/lib/modules/$kernel/kernel/drivers/net/wireless"
firmware_bin="rtl8188eufw.bin"
firmware_dir="/lib/firmware/rtlwifi"
if [ -f $firmware_bin ] ; then
echo "installing firmware $firmware_bin"
sudo install -p -m 644 $firmware_bin $firmware_dir
fi
echo "installing kernel module $module_bin"
sudo install -p -m 644 $module_bin $module_dir
sudo depmod -a
#sudo modprobe -r 8188eu || true # cannot currently be removed ("permanent")
sudo modprobe -i 8188eu
lsmod | grep -q 8188eu || echo "error: module not loaded"
As per latest update dl.dropboxusercontent.com is no longer valid and should be substituted by http://www.fars-robotics.net/, but dl.dropboxusercontent.com worked for me. Now my wifi is working.
uname -a; ifconfig wlan0; lsmod | grep 8188; lsusb
Linux DietPi 4.4.11-v7+ #886 SMP Thu May 19 15:20:49 BST 2016 armv7l GNU/Linux
wlan0 Link encap:Ethernet HWaddr 00:e0:4c:81:89:01
inet addr:192.168.0.102 Bcast:192.168.0.255 Mask:255.255.255.0
inet6 addr: fe80::2e0:4cff:fe81:8901/64 Scope:Link
UP BROADCAST RUNNING MULTICAST MTU:1500 Metric:1
RX packets:2262 errors:0 dropped:10 overruns:0 frame:0
TX packets:1659 errors:0 dropped:3 overruns:0 carrier:0
collisions:0 txqueuelen:1000
RX bytes:463049 (452.1 KiB) TX bytes:274451 (268.0 KiB)
8188eu 859474 0
cfg80211 427855 1 8188eu
Bus 001 Device 004: ID 0bda:8179 Realtek Semiconductor Corp.
Bus 001 Device 003: ID 0424:ec00 Standard Microsystems Corp. SMSC9512/9514 Fast Ethernet Adapter
Bus 001 Device 002: ID 0424:9514 Standard Microsystems Corp.
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
And below are my available kernels.
ls -ltr /lib/modules
total 28
drwxr-xr-x 3 root root 4096 Mar 18 2016 4.1.18-v7+
drwxr-xr-x 3 root root 4096 Nov 17 23:58 4.9.62+
drwxr-xr-x 3 root root 4096 Dec 30 12:36 4.9.35+
drwxr-xr-x 3 root root 4096 Dec 30 12:36 4.9.35-v7+
drwxr-xr-x 3 root root 4096 Dec 30 14:52 4.9.62-v7+
drwxr-xr-x 3 root root 4096 Dec 30 19:49 4.4.11+
drwxr-xr-x 3 root root 4096 Dec 30 20:03 4.4.11-v7+